/*******************************************************************************
 * Copyright (c) 2008, 2011 Intel Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Stanislav Polevic, Intel - Initial API and Implementation 
 * 	  
 * $Id: BinaryFragmentLoader.java,v 1.2 2008/03/24 23:15:23 jkubasta Exp $ 
 *******************************************************************************/
package org.eclipse.hyades.loaders.util;

public interface BinaryFragmentLoader extends XMLFragmentLoader {
	public void addAttribute(String name, byte value);

	public void addAttribute(String name, short value);

	public void addAttribute(String name, int value);

	public void addAttribute(String name, long value);

	public void addAttribute(String name, double value);
	
	/** The following are faster alternatives to the above, con is an integer constant referring
		to the attribute being set. */
	public void addAttribute(int con, byte value);
	public void addAttribute(int con, short value);
	public void addAttribute(int con, int value);
	
	public void addAttribute(int con, long value);
	
	public void addAttribute(int con, double value);
	
	public void addAttribute(int con, String value);
}
