/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDMemberDescriptor.java,v 1.4 2009-05-05 15:49:21 paules Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.model.statistical;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SD Member Descriptor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This is the abstract class that all descriptor types need to relaize.  Specializations of this class represent the different types of data that are collected.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDMemberDescriptor#getRepresentation <em>Representation</em>}</li>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDMemberDescriptor#getSnapshotObservation <em>Snapshot Observation</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDMemberDescriptor()
 * @model abstract="true"
 * @generated
 */
public interface SDMemberDescriptor extends SDDescriptor{
	/**
	 * Returns the value of the '<em><b>Representation</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.model.statistical.SDRepresentation#getMemberDescriptor <em>Member Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Representation</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Representation</em>' containment reference.
	 * @see #setRepresentation(SDRepresentation)
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDMemberDescriptor_Representation()
	 * @see org.eclipse.hyades.model.statistical.SDRepresentation#getMemberDescriptor
	 * @model opposite="memberDescriptor" containment="true" required="true"
	 * @generated
	 */
	SDRepresentation getRepresentation();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.model.statistical.SDMemberDescriptor#getRepresentation <em>Representation</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Representation</em>' containment reference.
	 * @see #getRepresentation()
	 * @generated
	 */
	void setRepresentation(SDRepresentation value);

	/**
	 * Returns the value of the '<em><b>Snapshot Observation</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.model.statistical.SDSnapshotObservation}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getMemberDescriptor <em>Member Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Snapshot Observation</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Snapshot Observation</em>' reference list.
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDMemberDescriptor_SnapshotObservation()
	 * @see org.eclipse.hyades.model.statistical.SDSnapshotObservation#getMemberDescriptor
	 * @model opposite="memberDescriptor"
	 * @generated
	 */
	EList<SDSnapshotObservation> getSnapshotObservation();

} // SDMemberDescriptor
