/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SDSnapshotObservation.java,v 1.4 2009-05-05 15:50:56 paules Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.model.statistical;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SD Snapshot Observation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * All observations are specializations of this class.  The individual observation values reside in the specialization instances.  
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getValidityMask <em>Validity Mask</em>}</li>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getCreationTime <em>Creation Time</em>}</li>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getMemberDescriptor <em>Member Descriptor</em>}</li>
 *   <li>{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getWindow <em>Window</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDSnapshotObservation()
 * @model abstract="true"
 * @generated
 */
public interface SDSnapshotObservation extends EObject{
	/**
	 * Returns the value of the '<em><b>Validity Mask</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Byte}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Validity Mask</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This is a bitmask for the indices of the observation instance array fields.  It is possoble for a counter to become active/inactive at any point during a window.  This mask allows a means of marking whether a particular field contains a valid value.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Validity Mask</em>' attribute list.
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDSnapshotObservation_ValidityMask()
	 * @model unique="false"
	 * @generated
	 */
	EList<Byte> getValidityMask();

	/**
	 * Returns the value of the '<em><b>Creation Time</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.Double}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Creation Time</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Creation Time</em>' attribute list.
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDSnapshotObservation_CreationTime()
	 * @model unique="false"
	 * @generated
	 */
	EList<Double> getCreationTime();

	/**
	 * Returns the value of the '<em><b>Member Descriptor</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.model.statistical.SDMemberDescriptor#getSnapshotObservation <em>Snapshot Observation</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Member Descriptor</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Member Descriptor</em>' reference.
	 * @see #setMemberDescriptor(SDMemberDescriptor)
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDSnapshotObservation_MemberDescriptor()
	 * @see org.eclipse.hyades.model.statistical.SDMemberDescriptor#getSnapshotObservation
	 * @model opposite="snapshotObservation" required="true"
	 * @generated
	 */
	SDMemberDescriptor getMemberDescriptor();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getMemberDescriptor <em>Member Descriptor</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Member Descriptor</em>' reference.
	 * @see #getMemberDescriptor()
	 * @generated
	 */
	void setMemberDescriptor(SDMemberDescriptor value);

	/**
	 * Returns the value of the '<em><b>Window</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.model.statistical.SDSampleWindow#getObservations <em>Observations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Window</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Window</em>' container reference.
	 * @see #setWindow(SDSampleWindow)
	 * @see org.eclipse.hyades.model.statistical.StatisticalPackage#getSDSnapshotObservation_Window()
	 * @see org.eclipse.hyades.model.statistical.SDSampleWindow#getObservations
	 * @model opposite="observations" required="true"
	 * @generated
	 */
	SDSampleWindow getWindow();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.model.statistical.SDSnapshotObservation#getWindow <em>Window</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Window</em>' container reference.
	 * @see #getWindow()
	 * @generated
	 */
	void setWindow(SDSampleWindow value);

} // SDSnapshotObservation
