/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CFGCategory.java,v 1.7 2009-05-05 15:46:21 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.configuration.util.ICategory;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CFG Category</b></em>'.
 * @extends ICategory 
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getDisplayName <em>Display Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMode <em>Selection Mode</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionAmount <em>Selection Amount</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMultiplicity <em>Selection Multiplicity</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategory()
 * @model abstract="true"
 * @generated
 */
public interface CFGCategory extends CMNNamedElement, ICategory{
	/**
	 * Returns the value of the '<em><b>Display Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Display Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Display Name</em>' attribute.
	 * @see #setDisplayName(String)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategory_DisplayName()
	 * @model
	 * @generated
	 */
	String getDisplayName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getDisplayName <em>Display Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Display Name</em>' attribute.
	 * @see #getDisplayName()
	 * @generated
	 */
	void setDisplayName(String value);

	/**
	 * Returns the value of the '<em><b>Selection Mode</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Selection Mode</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Selection Mode</em>' attribute.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode
	 * @see #setSelectionMode(CFGCategorySelectionMode)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategory_SelectionMode()
	 * @model
	 * @generated
	 */
	CFGCategorySelectionMode getSelectionMode();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMode <em>Selection Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Selection Mode</em>' attribute.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode
	 * @see #getSelectionMode()
	 * @generated
	 */
	void setSelectionMode(CFGCategorySelectionMode value);

	/**
	 * Returns the value of the '<em><b>Selection Amount</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Selection Amount</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Selection Amount</em>' attribute.
	 * @see #setSelectionAmount(int)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategory_SelectionAmount()
	 * @model
	 * @generated
	 */
	int getSelectionAmount();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionAmount <em>Selection Amount</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Selection Amount</em>' attribute.
	 * @see #getSelectionAmount()
	 * @generated
	 */
	void setSelectionAmount(int value);

	/**
	 * Returns the value of the '<em><b>Selection Multiplicity</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Selection Multiplicity</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Selection Multiplicity</em>' attribute.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity
	 * @see #setSelectionMultiplicity(CFGCategorySelectionMultiplicity)
	 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage#getCFGCategory_SelectionMultiplicity()
	 * @model
	 * @generated
	 */
	CFGCategorySelectionMultiplicity getSelectionMultiplicity();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.configuration.CFGCategory#getSelectionMultiplicity <em>Selection Multiplicity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Selection Multiplicity</em>' attribute.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity
	 * @see #getSelectionMultiplicity()
	 * @generated
	 */
	void setSelectionMultiplicity(CFGCategorySelectionMultiplicity value);

} // CFGCategory
