/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: BVRInteractionOperandImpl.java,v 1.10 2009-05-05 15:46:20 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.fragments.impl;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.models.common.fragments.BVRCombinedFragment;
import org.eclipse.hyades.models.common.fragments.BVRInteractionConstraint;
import org.eclipse.hyades.models.common.fragments.BVRInteractionOperand;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.impl.BVRInteractionFragmentImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR Interaction Operand</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.impl.BVRInteractionOperandImpl#getInteractionFragments <em>Interaction Fragments</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.impl.BVRInteractionOperandImpl#getInteractionConstraint <em>Interaction Constraint</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.impl.BVRInteractionOperandImpl#getCombinedFragment <em>Combined Fragment</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVRInteractionOperandImpl extends BVRInteractionFragmentImpl implements BVRInteractionOperand
{
	/**
	 * The cached value of the '{@link #getInteractionFragments() <em>Interaction Fragments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInteractionFragments()
	 * @generated
	 * @ordered
	 */
	protected EList<BVRInteractionFragment> interactionFragments;

	/**
	 * The cached value of the '{@link #getInteractionConstraint() <em>Interaction Constraint</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInteractionConstraint()
	 * @generated
	 * @ordered
	 */
	protected BVRInteractionConstraint interactionConstraint;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVRInteractionOperandImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return Common_Behavior_FragmentsPackage.Literals.BVR_INTERACTION_OPERAND;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<BVRInteractionFragment> getInteractionFragments() {
		if (interactionFragments == null) {
			interactionFragments = new EObjectContainmentEList<BVRInteractionFragment>(BVRInteractionFragment.class, this, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS);
		}
		return interactionFragments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteractionConstraint getInteractionConstraint() {
		return interactionConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInteractionConstraint(BVRInteractionConstraint newInteractionConstraint, NotificationChain msgs) {
		BVRInteractionConstraint oldInteractionConstraint = interactionConstraint;
		interactionConstraint = newInteractionConstraint;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT, oldInteractionConstraint, newInteractionConstraint);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInteractionConstraint(BVRInteractionConstraint newInteractionConstraint) {
		if (newInteractionConstraint != interactionConstraint) {
			NotificationChain msgs = null;
			if (interactionConstraint != null)
				msgs = ((InternalEObject)interactionConstraint).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT, null, msgs);
			if (newInteractionConstraint != null)
				msgs = ((InternalEObject)newInteractionConstraint).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT, null, msgs);
			msgs = basicSetInteractionConstraint(newInteractionConstraint, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT, newInteractionConstraint, newInteractionConstraint));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRCombinedFragment getCombinedFragment() {
		if (eContainerFeatureID() != Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT) return null;
		return (BVRCombinedFragment)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCombinedFragment(BVRCombinedFragment newCombinedFragment, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newCombinedFragment, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCombinedFragment(BVRCombinedFragment newCombinedFragment) {
		if (newCombinedFragment != eInternalContainer() || (eContainerFeatureID() != Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT && newCombinedFragment != null)) {
			if (EcoreUtil.isAncestor(this, newCombinedFragment))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newCombinedFragment != null)
				msgs = ((InternalEObject)newCombinedFragment).eInverseAdd(this, Common_Behavior_FragmentsPackage.BVR_COMBINED_FRAGMENT__INTERACTION_OPERANDS, BVRCombinedFragment.class, msgs);
			msgs = basicSetCombinedFragment(newCombinedFragment, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT, newCombinedFragment, newCombinedFragment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetCombinedFragment((BVRCombinedFragment)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS:
				return ((InternalEList<?>)getInteractionFragments()).basicRemove(otherEnd, msgs);
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT:
				return basicSetInteractionConstraint(null, msgs);
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				return basicSetCombinedFragment(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				return eInternalContainer().eInverseRemove(this, Common_Behavior_FragmentsPackage.BVR_COMBINED_FRAGMENT__INTERACTION_OPERANDS, BVRCombinedFragment.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS:
				return getInteractionFragments();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT:
				return getInteractionConstraint();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				return getCombinedFragment();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS:
				getInteractionFragments().clear();
				getInteractionFragments().addAll((Collection<? extends BVRInteractionFragment>)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT:
				setInteractionConstraint((BVRInteractionConstraint)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				setCombinedFragment((BVRCombinedFragment)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS:
				getInteractionFragments().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT:
				setInteractionConstraint((BVRInteractionConstraint)null);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				setCombinedFragment((BVRCombinedFragment)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_FRAGMENTS:
				return interactionFragments != null && !interactionFragments.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__INTERACTION_CONSTRAINT:
				return interactionConstraint != null;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND__COMBINED_FRAGMENT:
				return getCombinedFragment() != null;
		}
		return super.eIsSet(featureID);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.hyades.models.common.facades.behavioral.IBlock#getActions()
	 */
	public List getActions() {
		return getInteractionFragments();
	}

} //BVRInteractionOperandImpl
