/**********************************************************************
 * Copyright (c) 2005, 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: NullConnectUtilUI.java,v 1.2 2006-11-07 00:31:11 samwai Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.security.internal.util;

import java.security.KeyStore;
import java.security.cert.X509Certificate;

import org.eclipse.core.runtime.IStatus;

public class NullConnectUtilUI implements IConnectUtilUI {

	public String getAlias() {
		// No-op; this is a stub class 		
		return null;
	}

	public void openCertificateDetailDialog(X509Certificate certificate) {
		// No-op; this is a stub class 		
	}

	public void openErrorDialog(String title, String message, IStatus err) {
		// No-op; this is a stub class 
	}

	public int openQuestionDialog(String title, String msg, String[] btnLabels) {
		// No-op; this is a stub class 
		return 1; // return 1 to cancel whatever is being asked (0 == ok)
	}

	public boolean openSaveCertificateDialog(KeyStore ks) {
		// No-op; this is a stub class 
		return false; // Don't save any certificates blindly
	}

	public IConnectUtilUser promptAuthentication(String hostName, String userName) {
		// No-op; this is a stub class 
		return null;
	}

}
