/*******************************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.hyades.trace.views.internal.context.java.formatters;

import java.util.List;

import org.eclipse.hyades.trace.views.internal.TraceUIMessages;
import org.eclipse.hyades.ui.provisional.context.IContextLabelFormatProvider;

public class CallsAttrLP extends IntegerAttrLP {
	
	public CallsAttrLP() {
		// Add comma separators for large numbers (bug 317486)
		super(true);
	}
	
	public String getDisplayStringFromElement(Object value, Object element, int mode) {
			if (mode == IContextLabelFormatProvider.MODE_COLUMN_HEADER)
				return TraceUIMessages._41;
			else 
				return super.getDisplayStringFromElement(value,element,mode);	
	}	
	
	protected List<Integer> internalSupportModes()
	{
		List<Integer> modes = super.internalSupportModes();
		modes.add(new Integer(IContextLabelFormatProvider.MODE_COLUMN_HEADER));
		return modes;
	}
}
