/*******************************************************************************
 * Copyright (c) 2005, 2012 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.hyades.ui.internal.dbresource;

import org.eclipse.core.runtime.Preferences;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 * @author apnan, Created on Mar 7, 2005
 * 
 */
public class DBResourceSupportPreferencePage extends PreferencePage implements IWorkbenchPreferencePage {

	protected DBResourceSupportUI dbResourceSupportUI;
	protected Preferences preferences;

	public DBResourceSupportPreferencePage() {
		super();
		// setPreferenceStore(store);
	}

	protected Control createContents(Composite parent) {
		if (dbResourceSupportUI != null)
			return dbResourceSupportUI.createControl(parent);
		return parent;
	}

	public void init(IWorkbench workbench) {
	}

	protected void performDefaults() {
		super.performDefaults();
		dbResourceSupportUI.initializeValues(true);
	}

	public boolean performOk() {
		dbResourceSupportUI.storeValues();
		return true;
	}

}
