/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IScaleProvider.java,v 1.2 2008-05-23 14:11:50 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.internal;

/**
 * Interface use to create a scale for unknown DAxis data class.
 * By default JScrib charts handle numbers and Date, for other data classes
 * you must implements this interface in property P_DATA_CLASS.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IScaleProvider 
{
  /** @return IScale object for a given data class (from P_DATA_CLASS property of DAxis) */
  public IScale newScaleFor( Class _data_class );
}
