/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGPolygon.java,v 1.2 2005-06-10 17:47:09 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.generator;
/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SVGPolygon.java,v 1.2 2005-06-10 17:47:09 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

import java.io.Serializable;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * <code>SVGPolygon</code> is a implementation class for Scalable Vector Graphics (SVG) 
 * "polygon" elements. 
 *
 * $Revision: 1.2 $
 */
public class SVGPolygon extends SVGPolygonBase implements Serializable {
	Element implementation;
	static final long serialVersionUID = 8363624754022970952L;	
	/**
	 * Sole constructor.
	 */
	public SVGPolygon() {
		super();
		setTagName("polygon");
	}	
	
	/**
	 * Creates the Document Object Model (DOM) implementation of the SVG "polygon" element
	 * 	
	 * @param Document the target SVG Document
	 * @param String the series of points
	 * @return Element the implementation.
	 * @throws NullPointerException ???
	 */
	public Element doImplementation(Document svgDocument, String points) throws NullPointerException {	
		setPoints(points);			
		
		try {
			implementation = super.doImplementation(svgDocument);		
		} catch (DOMException e) {}
		
		return implementation;
	}
		
	/**
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.generator.svg.SVGBase#getImplementation() 
	 */
	public Element getImplementation() {
		return implementation;
	}	
	
}
