/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ICarriageReturn.java,v 1.2 2008-05-23 14:12:18 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.drivers.ui.layout.internal;

/**
 * This interface provides the service used by the formater text layout
 * to know if the cell which have a carriage return before or/and after
 * the cell in a paragraph
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface ICarriageReturn {

    /** Returns true if the cell has a carriage return before */
    public boolean hasCRBefore();
    
    /** Returns true if the cell has a carriage return after */
    public boolean hasCRAfter();
  
}
