/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IImage.java,v 1.2 2008-05-23 14:11:51 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.igc.internal;

/**
 * Store image independantly from underlying graphic system.
 * Stored image might be loaded on request only...
 *
 * @see ImageProxy
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IImage 
{
  /** @return the width of image in pixel */
  public int getWidth();
  /** @return the height of image in pixel */
  public int getHeight();
  
  /**
   * @return pixel color using RGBA definition at given location. return transparent color (0) outside
   */
  public int getPixel(int x, int y);

}
