/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IVector.java,v 1.2 2008-05-23 14:11:51 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.igc.internal;

/**
 * Vector abstraction in 2D integer space.
 *
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public interface IVector 
{
  /**@return X coordinate of vector */
  public double getX();
  /**@return Y coordinate of vector */
  public double getY();
  /**Change X coordinate of vector */
  public void setX(double x);
  /**Change Y coordinate of vector */
  public void setY(double y);
  /**Change both coordinates */
  public void setVector( double x, double y );
  /**Change both coordinates */
  public void setVector( IVector vector );
  /** set vector norm to 1.0 */
  public void normalize();
  /** @return vector's norm */
  public double getNorm();
}
