/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: VBoolean.java,v 1.2 2008-05-23 14:11:52 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on Dec 9, 2003
 *
 */
package org.eclipse.tptp.platform.report.tools.internal;

/**
 * Store a boolean value that can be modified. 
 * 
 * @author ademuyser
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 */
public class VBoolean
{
   private boolean value_;
   
   /**
    * Create a false VBoolean.
    */
   public VBoolean()
   {
   	 value_=false;
   }
   
   /**
    * Create a valued VBoolean 
    */
   public VBoolean( boolean value )
   {
   	  value_ = value; 
   }
   
   /** @return current value */
   public  boolean getValue() { return value_;  }
   
   /**
    * Change value of this object.
    */
   public void setValue( boolean value )
   {
   	  value_ = value;
   }

   /** @return true if current value is true */
   public  boolean isTrue() { return value_;  }

   /** @return true if current value is false */
   public  boolean isFalse() { return !value_;  }
   
}
